package UI.GameState;


import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

public class BulletState  {

    public int locX, locY, diam , angle;
    private WallState walls;
    private boolean keySpace;
    private KeyHandler2 keyHandler2 = new KeyHandler2();
    private long createTime;


    public BulletState(WallState wallState , TankState tankState){
        this.walls = wallState ;
        // Initialize the game state and all elements ...
        locX = tankState.locX;
        locY = tankState.locY;
        angle = tankState.rotate;
        diam = 10;
        keySpace = false;
        tankState.getMyListener().add(keyHandler2);
        createTime = System.currentTimeMillis();
    }

    public void update(){
            if (walls.getWallForBullet(locX , locY) != null) {
                if (walls.getWallForBullet(locX, locY).isHorizontal()) {
                    angle = 360 - angle;
                }
                if (walls.getWallForBullet(locX, locY).isVertical()) {
                        angle = 180  - angle;
                }
            }
        locY += 10*Math.sin(Math.toRadians(angle) ) ;
        locX += 10*Math.cos(Math.toRadians(angle) ) ;
    }


    public long getCreateTime() {
        return createTime;
    }

    class KeyHandler2 extends KeyAdapter{
        @Override
        public void keyPressed(KeyEvent e){
            if (e.getKeyCode() == KeyEvent.VK_SPACE) {
                keySpace = true;
            }
        }

        @Override
        public void keyReleased(KeyEvent e){
            if (e.getKeyCode() == KeyEvent.VK_SPACE) {
                keySpace = false;
            }
        }

    }

}
